/* -*- buffer-read-only: t -*- vi: set ro: */
/* THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT. */
/* This file is part of Mailfromd.
   Copyright (C) 2005-2008, 2010-2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "mailfromd.h"

struct status_tab {
	mf_exception ex;
	char *name;
};

static struct status_tab std_status_tab[] = {
	{ mfe_success, "e_success" },
	{ mfe_not_found, "e_not_found" },
	{ mfe_failure, "e_failure" },
	{ mfe_temp_failure, "e_temp_failure" },
	{ mfe_ston_conv, "e_ston_conv" },
	{ mfe_divzero, "e_divzero" },
	{ mfe_regcomp, "e_regcomp" },
	{ mfe_invip, "e_invip" },
	{ mfe_invcidr, "e_invcidr" },
	{ mfe_invtime, "e_invtime" },
	{ mfe_dbfailure, "e_dbfailure" },
	{ mfe_range, "e_range" },
	{ mfe_url, "e_url" },
	{ mfe_noresolve, "e_noresolve" },
	{ mfe_io, "e_io" },
	{ mfe_macroundef, "e_macroundef" },
	{ mfe_eof, "e_eof" },
	{ 0, NULL }
};

static size_t usr_status_count;
static char **usr_status_tab;

#define USR_EX_TEXT "USER-DEFINED"

static const char *
user_exception_str(unsigned ex)
{
	size_t num = ex - mf_exception_count;
	if (num >= usr_status_count) {
		size_t nmax = num + 1;
		usr_status_tab = xrealloc(usr_status_tab,
					  nmax * sizeof(usr_status_tab[0]));
		memset(usr_status_tab + usr_status_count, 0,
		       (nmax - usr_status_count) * sizeof(usr_status_tab[0]));
		usr_status_count = num;
	}
	if (!usr_status_tab[num]) {
		char buf[sizeof(USR_EX_TEXT) + 1 + NUMERIC_BUFSIZE_BOUND];
		snprintf(buf, sizeof buf, USR_EX_TEXT "-%u", ex);
		usr_status_tab[num] = strdup (buf);
	}
	return usr_status_tab[num] ? usr_status_tab[num] : USR_EX_TEXT;
}

int
string_to_exception(const char *str, mf_exception *status)
{
	struct status_tab *sp;
	for (sp = std_status_tab; sp->name; sp++)
		if (strcmp(str, sp->name) == 0) {
			*status = sp->ex;
			return 0;
		}
	return 1;
}

const char *
mf_exception_str(unsigned ex)
{
	struct status_tab *sp;
	for (sp = std_status_tab; sp->name; sp++)
		if (sp->ex == ex)
			return sp->name;
	return user_exception_str(ex);
}

const char *
mf_status_str(mf_status s)
{
	switch (s) {
	case mf_success:
		return "success";
		
	case mf_not_found:
		return "not_found";
		
	case mf_failure:
		return "failure";
		
	case mf_temp_failure:
		return "temp_failure";
		
	case mf_timeout:
		return "timeout";
	}
	return "UNKNOWN";
}

mf_exception 
mf_status_to_exception(mf_status s)
{
	switch (s) {
	case mf_success:
		return mfe_success;
		
	case mf_not_found:
		return mfe_not_found;
		
	case mf_failure:
		return mfe_failure;
		
	case mf_temp_failure:
	case mf_timeout:
		return mfe_temp_failure;
	}
	return s;
}
